## trilinos 12.4.2

=== CMakeLists.txt ===
# @HEADER
# ************************************************************************
#
#            Trilinos: An Object-Oriented Solver Framework
#                 Copyright (2001) Sandia Corporation
#
#
# Copyright (2001) Sandia Corporation. Under the terms of Contract
# DE-AC04-94AL85000, there is a non-exclusive license for use of this
# work by or on behalf of the U.S. Government.  Export of this program
# may require a license from the United States Government.
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# NOTICE:  The United States Government is granted for itself and others
# acting on its behalf a paid-up, nonexclusive, irrevocable worldwide
# license in this data to reproduce, prepare derivative works, and
# perform publicly and display publicly.  Beginning five (5) years from
# July 25, 2001, the United States Government is granted for itself and
# others acting on its behalf a paid-up, nonexclusive, irrevocable
# worldwide license in this data to reproduce, prepare derivative works,
# distribute copies to the public, perform publicly and display
# publicly, and to permit others to do so.
#
# NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED STATES DEPARTMENT
# OF ENERGY, NOR SANDIA CORPORATION, NOR ANY OF THEIR EMPLOYEES, MAKES
# ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR
# RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY
# INFORMATION, APPARATUS, PRODUCT, OR PROCESS DISCLOSED, OR REPRESENTS
# THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
#
# ************************************************************************
# @HEADER

#
# A) Define your project name and set up major project options
#

# To be safe, define your minimum CMake version.  This may be newer than the
# min required by TriBITS.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11 FATAL_ERROR)

# Must set the project name as a variable at very beginning before including anything else
# We set the project name in a separate file so CTest scripts can use it.
INCLUDE(${CMAKE_SOURCE_DIR}/ProjectName.cmake)

# CMake requires that you declare the CMake project in the top-level file and
# not in an include file :-(
PROJECT(${PROJECT_NAME} NONE)

# Set default C++ standard to C++11
SET(Trilinos_ENABLE_CXX11_DEFAULT ON)

#
# B) Pull in the TriBITS system and execute
#

INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/tribits/TriBITS.cmake)

# Make Trilinos create <Package>Config.cmake files by default
SET(${PROJECT_NAME}_ENABLE_INSTALL_CMAKE_CONFIG_FILES_DEFAULT ON)
# Make Trilinos set up CPack support by default
SET(${PROJECT_NAME}_ENABLE_CPACK_PACKAGING_DEFAULT ON)
# Don't allow disabled subpackages to be excluded from tarball
SET(${PROJECT_NAME}_EXCLUDE_DISABLED_SUBPACKAGES_FROM_DISTRIBUTION_DEFAULT FALSE)

# Do all of the processing for this Tribits project
TRIBITS_PROJECT()

=== commonTools/gtest/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Gtest)

#
# B) Set up package-specific options
#

#
# C) Add the libraries, tests, and examples
#

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

APPEND_SET(HEADERS 
  ${CMAKE_CURRENT_SOURCE_DIR}/gtest/gtest.h
  )

APPEND_SET(SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/gtest/gtest-all.cc
  )

TRIBITS_ADD_LIBRARY(
  gtest
  NO_INSTALL_HEADERS ${HEADERS}
  SOURCES ${SOURCES}
  )

#install gtest header into the correct subdir.
INSTALL(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/${Trilinos_INSTALL_INCLUDE_DIR}/gtest/)



#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== demos/buildAgainstTrilinos/CMakeLists.txt ===
# CMAKE File for "MyApp" application building against an installed Trilinos

cmake_minimum_required(VERSION 2.7)

# Use Trilinos_PREFIX, if the user set it, to help find Trilinos.
# The final location will actually be held in Trilinos_DIR which must
# point at "<prefix>/lib/cmake/Trilinos", but this helps the search.
SET(CMAKE_PREFIX_PATH ${Trilinos_PREFIX} ${CMAKE_PREFIX_PATH})

# Get Trilinos as one entity
FIND_PACKAGE(Trilinos REQUIRED)

# Echo trilinos build info just for fun
MESSAGE("\nFound Trilinos!  Here are the details: ")
MESSAGE("   Trilinos_DIR = ${Trilinos_DIR}")
MESSAGE("   Trilinos_VERSION = ${Trilinos_VERSION}")
MESSAGE("   Trilinos_PACKAGE_LIST = ${Trilinos_PACKAGE_LIST}")
MESSAGE("   Trilinos_LIBRARIES = ${Trilinos_LIBRARIES}")
MESSAGE("   Trilinos_INCLUDE_DIRS = ${Trilinos_INCLUDE_DIRS}")
MESSAGE("   Trilinos_LIBRARY_DIRS = ${Trilinos_LIBRARY_DIRS}")
MESSAGE("   Trilinos_TPL_LIST = ${Trilinos_TPL_LIST}")
MESSAGE("   Trilinos_TPL_INCLUDE_DIRS = ${Trilinos_TPL_INCLUDE_DIRS}")
MESSAGE("   Trilinos_TPL_LIBRARIES = ${Trilinos_TPL_LIBRARIES}")
MESSAGE("   Trilinos_TPL_LIBRARY_DIRS = ${Trilinos_TPL_LIBRARY_DIRS}")
MESSAGE("   Trilinos_BUILD_SHARED_LIBS = ${Trilinos_BUILD_SHARED_LIBS}")
MESSAGE("End of Trilinos details\n")

# Make sure to use same compilers and flags as Trilinos
SET(CMAKE_CXX_COMPILER ${Trilinos_CXX_COMPILER} )
SET(CMAKE_C_COMPILER ${Trilinos_C_COMPILER} )
SET(CMAKE_Fortran_COMPILER ${Trilinos_Fortran_COMPILER} )

SET(CMAKE_CXX_FLAGS  "${Trilinos_CXX_COMPILER_FLAGS} ${CMAKE_CXX_FLAGS}")
SET(CMAKE_C_FLAGS  "${Trilinos_C_COMPILER_FLAGS} ${CMAKE_C_FLAGS}")
SET(CMAKE_Fortran_FLAGS  "${Trilinos_Fortran_COMPILER_FLAGS} ${CMAKE_Fortran_FLAGS}")

#
# End of setup and error checking
#  NOTE: PROJECT command checks for compilers, so this statement
#        is moved AFTER setting CMAKE_CXX_COMPILER from Trilinos

PROJECT(MyApp)

# MPI check 
MESSAGE("-- Checking if MPI is enabled in Trilinos:")
LIST(FIND Trilinos_TPL_LIST MPI MPI_List_ID)
IF (MPI_List_ID GREATER -1)
  MESSAGE("-- Checking if MPI is enabled in Trilinos: MPI ENABLED")
  SET(MYAPP_MPI TRUE)
  ADD_DEFINITIONS(-DMYAPP_MPI)
ELSE()
  MESSAGE("-- Checking if MPI is enabled in Trilinos: MPI NOT ENABLED")
  SET(MYAPP_MPI FALSE)
ENDIF()

# Set optional dependency in MyApp on Epetra package: 
#   this toggles code within  #ifdef MYAPP_EPETRA 
MESSAGE("-- Looking for Epetra:")
LIST(FIND Trilinos_PACKAGE_LIST Epetra Epetra_List_ID)
IF (Epetra_List_ID GREATER -1)
  ADD_DEFINITIONS(-DMYAPP_EPETRA)
  MESSAGE("-- Looking for Epetra: -- found, compiling with -DMYAPP_EPETRA")
  SET(MYAPP_EPETRA TRUE)
ELSE()
  MESSAGE("-- Looking for Epetra: -- not found.")
  SET(MYAPP_EPETRA FALSE)
ENDIF()

# Compile source code
ADD_SUBDIRECTORY(src)

#Turn on test to be run by ctest
ENABLE_TESTING()
ADD_SUBDIRECTORY(test)

=== packages/ForTrilinos/CMakeLists.txt ===


TRIBITS_PACKAGE(ForTrilinos Fortran)

IF("${CMAKE_Fortran_COMPILER_ID}" MATCHES "VisualAge|XL")
    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qfree=f90 -qxlf2003=polymorphic -qxlf2003=autorealloc -WF,-C!")
#    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qxlf2003=polymorphic -qxlf2003=autorealloc -qxlf90=autodealloc -WF,-C!")
    SET(ForTrilinos_UT_CPP_FLAGS -E -P -qnoppline)
    SET(ForTrilinos_UT_CPP ${CMAKE_C_COMPILER})
ELSE()
    SET(ForTrilinos_UT_CPP_FLAGS "")
    SET(ForTrilinos_UT_CPP cpp)
ENDIF()

# Previously, unit testing required support for long lines
# Enabled by default for: "NAG", "XL", Intel
# Limited support: "PGI" (limited to ~250)
# Flag needed for: "GNU"
IF("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -ffree-line-length-none")
ENDIF()
#IF("${CMAKE_Fortran_COMPILER_ID}" MATCHES "VisualAge|XL|NAG|Intel|GNU")
#    SET(FORTRILINOS_COMPILER_SUPPORTS_LONG_LINES 1)
#ENDIF()
# NOT: Now, unit testing only requires Perl be installed and in the path

# A) Package-specific configuration options
#

# Normalize flags for preprocessing by Fortran compilers
FOREACH(var
    HAVE_FORTRILINOS_EXAMPLES
    HAVE_FORTRILINOS_TESTS
    HAVE_EXAMPLES
    HAVE_EXPORT_MAKEFILES
    HAVE_GNUMAKE
    ForTrilinos_ASSERTIONS
    HAVE_MPI
    HAVE_TESTS
    HAVE_TEUCHOS_COMPLEX
    ForTrilinos_ENABLE_EXTENDED  # DEPRECATED Flag remove in Trilinos 11.0, change to ForTrilinos_ENABLE_OBJECT_ORIENTED
    ForTrilinos_ENABLE_OBJECT_ORIENTED
    ForTrilinos_DISABLE_DEFERRED_LENGTH_CHARACTERS
    ForTrilinos_DISABLE_FINAL_SUBROUTINES
    HAVE_FORTRILINOS_AMESOS
    ForTrilinos_ENABLE_Amesos
    HAVE_FORTRILINOS_AZTECOO
    ForTrilinos_ENABLE_AztecOO
    HAVE_FORTRILINOS_IFPACK
    ForTrilinos_ENABLE_Ifpack
    HAVE_FORTRILINOS_GALERI
    ForTrilinos_ENABLE_Galeri
    HAVE_FORTRILINOS_PLIRIS
    ForTrilinos_ENABLE_Pliris
    )
  IF(${var})
    SET(ForTrilinos_config_${var} 1)
  ELSE()
    SET(ForTrilinos_config_${var} 0)
  ENDIF()
ENDFOREACH()

TRIBITS_CONFIGURE_FILE(${PACKAGE_NAME}_config.h)




ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/PyTrilinos/CMakeLists.txt ===
# -*- cmake -*-

# @HEADER
# ***********************************************************************
#
#          PyTrilinos: Python Interfaces to Trilinos Packages
#                 Copyright (2014) Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia
# Corporation, the U.S. Government retains certain rights in this
# software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Questions? Contact William F. Spotz (wfspotz@sandia.gov)
#
# ***********************************************************************
# @HEADER

# Include the package macros

# Set the package name
TRIBITS_PACKAGE(PyTrilinos DISABLE_STRONG_WARNINGS)

IF(NOT BUILD_SHARED_LIBS)
  MESSAGE(FATAL_ERROR "PyTrilinos can only be built with shared libraries. Building of shared libraries is currently set to OFF. To enable shared libraries please set the cache variable \"BUILD_SHARED_LIBS\" to ON")
ENDIF()

# Set the package version number
SET(PyTrilinos_VERSION 12.3 (Dev))

# Define the list of PyTrilinos packages and modules.  Packages are
# the top-level names only, such as Epetra, AztecOO and NOX.  The list
# of modules is similar to the packages, except it contains the names
# of python modules that correspond to nested namespaces, such as
# NOX.__init__ or NOX.Epetra.Interface.
SET(PyTrilinos_PACKAGES "")
SET(PyTrilinos_MODULES  "")

APPEND_SET(PyTrilinos_PACKAGES Teuchos)
APPEND_SET(PyTrilinos_MODULES  Teuchos)

IF(PyTrilinos_ENABLE_Epetra)
  APPEND_SET(PyTrilinos_PACKAGES Epetra)
  APPEND_SET(PyTrilinos_MODULES  Epetra)
ENDIF(PyTrilinos_ENABLE_Epetra)

IF(PyTrilinos_ENABLE_Triutils)
  APPEND_SET(PyTrilinos_PACKAGES TriUtils)
  APPEND_SET(PyTrilinos_MODULES  TriUtils)
ENDIF(PyTrilinos_ENABLE_Triutils)

IF(PyTrilinos_ENABLE_Tpetra)
  APPEND_SET(PyTrilinos_PACKAGES Tpetra)
  APPEND_SET(PyTrilinos_MODULES  Tpetra)
ENDIF(PyTrilinos_ENABLE_Tpetra)

IF(PyTrilinos_ENABLE_Domi)
  APPEND_SET(PyTrilinos_PACKAGES Domi)
  APPEND_SET(PyTrilinos_MODULES  Domi)
ENDIF(PyTrilinos_ENABLE_Domi)

IF(PyTrilinos_ENABLE_EpetraExt)
  APPEND_SET(PyTrilinos_PACKAGES EpetraExt)
  APPEND_SET(PyTrilinos_MODULES  EpetraExt)
ENDIF(PyTrilinos_ENABLE_EpetraExt)

IF(PyTrilinos_ENABLE_Isorropia)
  APPEND_SET(PyTrilinos_PACKAGES Isorropia         )
  APPEND_SET(PyTrilinos_MODULES  Isorropia.__init__)
  Append_SET(PyTrilinos_MODULES  Isorropia.Epetra  )
ENDIF(PyTrilinos_ENABLE_Isorropia)

IF(PyTrilinos_ENABLE_Pliris)
  APPEND_SET(PyTrilinos_PACKAGES Pliris)
  APPEND_SET(PyTrilinos_MODULES  Pliris)
ENDIF(PyTrilinos_ENABLE_Pliris)

IF(PyTrilinos_ENABLE_AztecOO)
  APPEND_SET(PyTrilinos_PACKAGES AztecOO)
  APPEND_SET(PyTrilinos_MODULES  AztecOO)
ENDIF(PyTrilinos_ENABLE_AztecOO)

IF(PyTrilinos_ENABLE_Galeri)
  APPEND_SET(PyTrilinos_PACKAGES Galeri)
  APPEND_SET(PyTrilinos_MODULES  Galeri)
ENDIF(PyTrilinos_ENABLE_Galeri)

IF(PyTrilinos_ENABLE_Amesos)
  APPEND_SET(PyTrilinos_PACKAGES Amesos)
  APPEND_SET(PyTrilinos_MODULES  Amesos)
ENDIF(PyTrilinos_ENABLE_Amesos)

IF(PyTrilinos_ENABLE_Ifpack)
  APPEND_SET(PyTrilinos_PACKAGES IFPACK)
  APPEND_SET(PyTrilinos_MODULES  IFPACK)
ENDIF(PyTrilinos_ENABLE_Ifpack)

IF(PyTrilinos_ENABLE_Komplex)
  APPEND_SET(PyTrilinos_PACKAGES Komplex)
  APPEND_SET(PyTrilinos_MODULES  Komplex)
ENDIF(PyTrilinos_ENABLE_Komplex)

IF(PyTrilinos_ENABLE_Anasazi)
  APPEND_SET(PyTrilinos_PACKAGES Anasazi)
  APPEND_SET(PyTrilinos_MODULES  Anasazi)
ENDIF(PyTrilinos_ENABLE_Anasazi)

IF(PyTrilinos_ENABLE_ML)
  APPEND_SET(PyTrilinos_PACKAGES ML)
  APPEND_SET(PyTrilinos_MODULES  ML)
ENDIF(PyTrilinos_ENABLE_ML)

IF(PyTrilinos_ENABLE_NOX)
  APPEND_SET(PyTrilinos_PACKAGES NOX)
  APPEND_SET(PyTrilinos_MODULES  NOX.__init__  )
  APPEND_SET(PyTrilinos_MODULES  NOX.Abstract  )
  APPEND_SET(PyTrilinos_MODULES  NOX.StatusTest)
  APPEND_SET(PyTrilinos_MODULES  NOX.Solver    )
  IF(NOX_ENABLE_Epetra)
    APPEND_SET(PyTrilinos_MODULES NOX.Epetra.__init__ )
    APPEND_SET(PyTrilinos_MODULES NOX.Epetra.Interface)
  ENDIF(NOX_ENABLE_Epetra)
  IF(NOX_ENABLE_PETSC)
    APPEND_SET(PyTrilinos_MODULES NOX.PETSc.__init__ )
    APPEND_SET(PyTrilinos_MODULES NOX.PETSc.Interface)
  ENDIF(NOX_ENABLE_PETSC)
ENDIF(PyTrilinos_ENABLE_NOX)

IF(NOX_ENABLE_LOCA)
  APPEND_SET(PyTrilinos_PACKAGES LOCA                                )
  APPEND_SET(PyTrilinos_MODULES  LOCA.__init__                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Abstract                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.AnasaziOperator                )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Bifurcation                    )
  APPEND_SET(PyTrilinos_MODULES  LOCA.BorderedSolver                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.BorderedSystem                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Eigensolver                    )
  APPEND_SET(PyTrilinos_MODULES  LOCA.EigenvalueSort                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Extended                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Homotopy                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Hopf.__init__                  )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Hopf.MinimallyAugmented        )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Hopf.MooreSpence               )
  APPEND_SET(PyTrilinos_MODULES  LOCA.MultiContinuation              )
  APPEND_SET(PyTrilinos_MODULES  LOCA.MultiPredictor                 )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Parameter                      )
  APPEND_SET(PyTrilinos_MODULES  LOCA.PhaseTransition                )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Pitchfork.__init__             )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Pitchfork.MinimallyAugmented   )
  APPEND_SET(PyTrilinos_MODULES  LOCA.Pitchfork.MooreSpence          )
  APPEND_SET(PyTrilinos_MODULES  LOCA.SaveEigenData                  )
  APPEND_SET(PyTrilinos_MODULES  LOCA.StatusTest                     )
  APPEND_SET(PyTrilinos_MODULES  LOCA.StepSize                       )
  APPEND_SET(PyTrilinos_MODULES  LOCA.TimeDependent                  )
  APPEND_SET(PyTrilinos_MODULES  LOCA.TurningPoint.__init__          )
  APPEND_SET(PyTrilinos_MODULES  LOCA.TurningPoint.MinimallyAugmented)
  APPEND_SET(PyTrilinos_MODULES  LOCA.TurningPoint.MooreSpence       )
  IF(NOX_ENABLE_Epetra)
    APPEND_SET(PyTrilinos_MODULES  LOCA.Epetra.__init__ )
    APPEND_SET(PyTrilinos_MODULES  LOCA.Epetra.Interface)
  ENDIF(NOX_ENABLE_Epetra)
ENDIF(NOX_ENABLE_LOCA)

# Python interpreter, library, and header files are required.
FIND_PACKAGE(PythonInterp 2.5 REQUIRED)
#FIND_PACKAGE(PythonLibs 2.5 REQUIRED)
FIND_PACKAGE(PythonInclude REQUIRED)

# Python module numpy is required
FIND_PACKAGE(NumPy 1.0 REQUIRED)

# Simple wrapper interface generator (SWIG) is required
SET(SWIG_VERSION_FLOOR   3.0.0)
FIND_PACKAGE(SWIG REQUIRED)
IF(${SWIG_VERSION} VERSION_LESS ${SWIG_VERSION_FLOOR})
  MESSAGE(FATAL_ERROR
    "SWIG version " ${SWIG_VERSION}
    " is less than minimum version " ${SWIG_VERSION_FLOOR}
    )
ENDIF()
# ${SWIG_USE_FILE} is hard-coded to be the installed UseSWIG.cmake
# file.  We want to include the local, modified version.
INCLUDE(UseSWIG)

# Python module mpi4py is optional, and only of interest if MPI is
# enabled
IF(TPL_ENABLE_MPI)
  SET(TPL_ENABLE_MPI4PY ON CACHE BOOL "Use Mpi4Py")
  IF(TPL_ENABLE_MPI4PY)
    FIND_PACKAGE(Mpi4Py)
  ELSE(TPL_ENABLE_MPI4PY)
    SET(Mpi4Py_FOUND OFF)
  ENDIF(TPL_ENABLE_MPI4PY)
ENDIF(TPL_ENABLE_MPI)

# Python module petsc4py is required if NOX_ENABLE_PETSC is true
IF(NOX_ENABLE_PETSC)
  FIND_PACKAGE(PETSc4Py REQUIRED)
ENDIF(NOX_ENABLE_PETSC)

# Print the enabled PyTrilinos packages
MESSAGE(STATUS "Enabled PyTrilinos modules:")
MESSAGE(STATUS "    ${PyTrilinos_PACKAGES}")

# Determine the PyTrilinos default installation directory prefix.  If
# CMAKE_INSTALL_PREFIX is set by the user, then use it.  Else the
# prefix is set to the value of python's sys.prefix.
EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c "import sys; print sys.prefix"
  OUTPUT_VARIABLE PYTHON_PREFIX
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  SET(PyTrilinos_DEFAULT_INSTALL_PREFIX ${PYTHON_PREFIX})
ELSE(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  SET(PyTrilinos_DEFAULT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Set the PyTrilinos install prefix
SET(PyTrilinos_INSTALL_PREFIX ${PyTrilinos_DEFAULT_INSTALL_PREFIX}
  CACHE PATH "The path prefix for where PyTrilinos will be installed, e.g. /usr/local")

# The default status for whether we build docstrings for PyTrilinos is
# based on whether the user has doxygen installed.
FIND_PACKAGE(Doxygen)
IF(DOXYGEN_FOUND)
  SET(PyTrilinos_DOCSTRINGS_DEFAULT ON)
ELSE(DOXYGEN_FOUND)
  SET(PyTrilinos_DOCSTRINGS_DEFAULT OFF)
  MESSAGE(STATUS "doxygen not found!")
ENDIF(DOXYGEN_FOUND)

# Set the PyTrilinos docstrings flag
SET(PyTrilinos_DOCSTRINGS ${PyTrilinos_DOCSTRINGS_DEFAULT} CACHE BOOL
    "a flag that determines whether Python docstrings will be built using doxygen")
IF(PyTrilinos_DOCSTRINGS AND NOT DOXYGEN_FOUND)
  MESSAGE(ERROR "PyTrilinos docstrings enabled but doxygen not found")
ENDIF(PyTrilinos_DOCSTRINGS AND NOT DOXYGEN_FOUND)

# Add the util directory
ADD_SUBDIRECTORY(util)

# Add the doc directory, which builds the python documentation strings
ADD_SUBDIRECTORY(doc)

# Add the src directory, which builds the pytrilinos library,
# generates the wrapper code, builds the PyTrilinos python package and
# compiles the PyTrilinos extension modules
ADD_SUBDIRECTORY(src)

# Add the test scripts
TRIBITS_ADD_TEST_DIRECTORIES(test)

# Add the example scripts
TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  doc/PyTrilinos-SciProg/CoupledSolver.png
  doc/PyTrilinos-SciProg/CoupledSolver.pptx
  doc/PyTrilinos-SciProg/PyTrilinos.bib
  doc/PyTrilinos-SciProg/PyTrilinos.tex
  doc/PyTrilinos-SciProg/Response.pdf
  doc/PyTrilinos-SciProg/Response.tex
  doc/PyTrilinos-SciProg/cage12rcb8.png
  )

# Execute the package postprocessing
TRIBITS_PACKAGE_POSTPROCESS()

=== packages/amesos/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Amesos)

#
# B) Set up package-specific options
#

# if using SuperLUDist, must also link in ParMETIS for some reason
IF(${PACKAGE_NAME}_ENABLE_SuperLUDist AND NOT ${PACKAGE_NAME}_ENABLE_ParMETIS)
  MESSAGE(FATAL_ERROR "The Amesos support for the SuperLUIDist TPL requires the ParMETIS TPL.  Either disable Amesos SuperLUDist support or enable the ParMETIS TPL.")
ENDIF()

# if using parallel MUMPS, must also link in scalapack and BLACS

IF(${PACKAGE_NAME}_ENABLE_MUMPS AND ${PACKAGE_NAME}_ENABLE_MPI AND NOT ${PACKAGE_NAME}_ENABLE_SCALAPACK)
  MESSAGE(FATAL_ERROR "The Amesos support for parallel MUMPS requires SCALAPACK.")
ENDIF()

IF(${PACKAGE_NAME}_ENABLE_MUMPS AND ${PACKAGE_NAME}_ENABLE_MPI AND NOT ${PACKAGE_NAME}_ENABLE_BLACS)
  MESSAGE(FATAL_ERROR "The Amesos support for parallel MUMPS requires BLACS.")
ENDIF()

## Most of the options below are bogus.  The handling of TPLs is done
## through the dependencies file.  This needs to be cleaned up. I'm
## leaving them for now so that we have a list of all options.  They
## will be removed as correct TPL support is added.

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_DSCPACK
  HAVE_AMESOS_DSCPACK
  "Enable DSCPACK functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_MC64
  HAVE_AMESOS_MC64
  "Enable MC64 functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_KLU
  HAVE_AMESOS_KLU
  "Enable KLU (Tim Davis's Files)."
  ON )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARDISO
  HAVE_AMESOS_PARDISO
  "Enable PARDISO functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARDISO_MKL
  HAVE_AMESOS_PARDISO_MKL
  "Enable PARDISO functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARAKLETE
  HAVE_AMESOS_PARAKLETE
  "Enable PARAKLETE functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_LAPACK
  HAVE_AMESOS_LAPACK
  "Enable LAPACK functionality."
  ON )
  
# ...

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  doc/AmesosOverview
  doc/PARA06
  example/RunParaklete.cpp
  example/Thyra_AmesosLinearOpWithSolveFactory.cpp
  example/pk.h
  example/run_pk.c
  example/simpleStratimikosSolve.cpp
  example/simpleStratimikosSolve.hpp
  example/stratimikos_example.cpp
  src/Amesos_BTF.h
  src/Amesos_Component.h
  src/Amesos_Merikos.h
  src/Amesos_BTF.h
  src/SuiteSparse/CAMD/Source/amesos_camd_1.c
  src/SuiteSparse/CAMD/Source/amesos_camd_aat.c
  src/SuiteSparse/CAMD/Source/amesos_camd_control.c
  src/SuiteSparse/CAMD/Source/amesos_camd_defaults.c
  src/SuiteSparse/CAMD/Source/amesos_camd_dump.c
  src/SuiteSparse/CAMD/Source/amesos_camd_info.c
  src/SuiteSparse/CAMD/Source/amesos_camd_order.c
  src/SuiteSparse/CAMD/Source/amesos_camd_preprocess.c
  src/SuiteSparse/CAMD/Source/amesos_camd_valid.c
  src/SuiteSparse/CCOLAMD/Source/amesos_ccolamd.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_amd.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_analyze.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_colamd.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_etree.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_factorize.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_postorder.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_rcond.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_resymbol.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_rowcolcounts.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_rowfac.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_solve.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_spsolve.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_t_cholmod_rowfac.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_aat.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_add.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_band.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_change_factor.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_copy.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_dense.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_factor.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_camd.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_ccolamd.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_csymamd.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_metis.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_nesdis.c
  src/src-repository
  src/stamp-h.in
  test/TestOptions/Dummy
  test/Test_Basic/NotQuiteDense.triU
  test/Test_Performance/In_Test_UmfpackPerformance.csh
  test/scripts/daily/mpi/TestBasic.sh
  test/scripts/daily/serial/TestAmesos.sh
  )

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/amesos2/CMakeLists.txt ===

#
# A) Define the package
#

TRIBITS_PACKAGE(Amesos2)

SET(${PACKAGE_NAME_UC}_VERSION "0.3d")
SET(${PACKAGE_NAME_UC}_RELEASE_DATE "07/28/2011")

#
# B) Set up package-specific options
#


TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_VERBOSE_DEBUG
  HAVE_${PACKAGE_NAME_UC}_VERBOSE_DEBUG
  "Enable verbose output during debug-mode"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_TIMERS
  HAVE_${PACKAGE_NAME_UC}_TIMERS
  "Enable performance timers"
  OFF )

#
# TPL Solver interfaces are enabled automatically based on Trilinos
# TPL configuration.
#
# Config options such as Amesos2_ENABLE_XXXXXX are automatically
# generated in case a user would wish to explicitely disable Amesos2
# support for an otherwise enabled third-part solver library
#


IF(${PACKAGE_NAME}_ENABLE_Cholmod)
  SET(HAVE_AMESOS2_CHOLMOD ON )
ENDIF()


TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_LAPACK
  HAVE_${PACKAGE_NAME_UC}_LAPACK
  "Enable the dense serial solver interface"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_KLU2
  HAVE_AMESOS2_KLU2
  "Enable KLU2 in Amesos2"
  ON
)

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Basker
   HAVE_AMESOS2_BASKER
   "Enable Basker in Amesos2"
   OFF
)

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_MUMPS
        HAVE_AMESOS2_MUMPS
        "Enable MUMPS in Amesos2"
        OFF
)

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_AMESOS2_EXPERIMENTAL
  "Enable building and installation of experimental Amesos2 features."
  NO )

TRIBITS_ADD_DEBUG_OPTION()

TRIBITS_ADD_EXPLICIT_INSTANTIATION_OPTION()

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# D) Do standard postprocessing
#

#leaving in place for future excludes
#TRIBITS_EXCLUDE_FILES(
#  )

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/anasazi/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE( Anasazi ENABLE_SHADOWING_WARNINGS )

# 2009/05/01: rabartl: I have removed 'CLEANED' from above from now because it
# fails to compile with gcc 3.4.6 (see bug 4395).

#
# B) Set up package-specific options
#

TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

# RBGen support
TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_RBGen
  HAVE_ANASAZI_RBGEN
  "Enable Reduced Basis Generation (RBGen) support in Anasazi"
  OFF )

# Anasazi includes tests that may require complex arithmetic in order
# to build.  These include especially (but not exclusively) the
# Tpetra-specific tests, since Tpetra objects are templated on the
# Scalar data type.  We don't want to build tests that depend on
# complex arithmetic if the rest of Trilinos (esp. Teuchos, since we
# need e.g., Teuchos::ScalarTraits< Scalar >) was not built with
# complex arithmetic support.  Thus, we define an appropriate package
# configuration variable ${PACKAGE_NAME}_ENABLE_COMPLEX, which we can
# use to decide whether or not to build particular tests.
#
# The default value of this config variable should be the same as
# Teuchos_ENABLE_COMPLEX, because most of Anasazi's complex-arithmetic
# tests depend heavily on Teuchos' complex arithmetic support.

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_COMPLEX
  HAVE_ANASAZI_COMPLEX
  "Enable Anasazi features for complex data types."
  "${Teuchos_ENABLE_COMPLEX}" )

# Kokkos includes an implementation of the Tall Skinny QR (TSQR)
# factorization.  TSQR is used to implement an OrthoManager
# (Anasazi::TsqrOrthoManager) and a MatOrthoManager (which only uses
# TSQR in the Euclidean-inner-product case).  TSQR is enabled by
# default if the KokkosTSQR and Tpetra packages are enabled, but users
# have control over Tpetra_ENABLE_TSQR.  Note that the Epetra adapter
# for TSQR currently lives in Tpetra.

IF (${PACKAGE_NAME}_ENABLE_Tpetra AND Tpetra_ENABLE_TSQR)
  GLOBAL_SET(${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT ON)
ELSE()
  GLOBAL_SET(${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT OFF)
ENDIF()
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_TSQR
  HAVE_ANASAZI_TSQR
  "Enable TSQR (Tall Skinny QR factorization) support in Anasazi."
  "${${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT}")

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_TEUCHOS_TIME_MONITOR
  ANASAZI_TEUCHOS_TIME_MONITOR
  "Build with Teuchos TimeMonitors enabled."
  "${${PROJECT_NAME}_ENABLE_TEUCHOS_TIME_MONITOR}" )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_Tpetra_Timers
  HAVE_ANASAZI_TPETRA_TIMERS
  "Add timers to Anasazi::MultiVecTraits for Tpetra multivectors."
  NO
  )

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

IF (${PACKAGE_NAME}_ENABLE_RBGen)
  ADD_SUBDIRECTORY(src-rbgen)
ENDIF()

IF (Anasazi_ENABLE_Epetra)
  ADD_SUBDIRECTORY(epetra)
ENDIF()

TRIBITS_ADD_TEST_DIRECTORIES(test)

IF (Anasazi_ENABLE_ThyraCore)
  ADD_SUBDIRECTORY(thyra)
ENDIF()

IF (Anasazi_ENABLE_Tpetra)
  ADD_SUBDIRECTORY(tpetra)
ENDIF()

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  doc/TOMS
  doc/OrthoStudy
  doc/ThyraPerf
  src/ModalAnalysisSolvers
  )

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/belos/CMakeLists.txt ===

######################################################################
## Define the package
######################################################################

TRIBITS_PACKAGE(Belos)

######################################################################
## Set up package-specific options
######################################################################

TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

# Kokkos includes an implementation of the Tall Skinny QR (TSQR)
# factorization.  TSQR is used to implement an OrthoManager and a
# MatOrthoManager (which only uses TSQR in the Euclidean-inner-product
# case).  TSQR is enabled by default if the KokkosTSQR and Tpetra
# packages are enabled, but users have control over
# Tpetra_ENABLE_TSQR.  Note that the Epetra adapter for TSQR currently
# lives in Tpetra.
#
# mfh 05 Sep 2012: Back in 2010, I had to put Epetra's TSQR adapter in
# Tpetra.  This was because an external software package was linking
# to Epetra without using Trilinos' Makefile.export mechanism to
# consider which Trilinos libraries to use.  Making Epetra optionally
# depend on Kokkos (to make TSQR work) changed the list of libraries,
# and that software package wasn't doing the right thing to adjust.
# In any case, I chose at the time to put Epetra's TSQR adapter in
# Tpetra, since Tpetra already had an optional dependency on Epetra.
# So, for better or worse, you won't be able to use TSQR with Epetra
# unless you enable both Epetra and Tpetra in your Trilinos build.
# HAVE_BELOS_TSQR will correctly reflect this: it won't be defined 
# unless both Epetra and Tpetra are enabled in your Trilinos build.
IF (${PACKAGE_NAME}_ENABLE_Epetra AND ${PACKAGE_NAME}_ENABLE_Tpetra AND Tpetra_ENABLE_TSQR)
  GLOBAL_SET(${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT ON)
ELSE()
  GLOBAL_SET(${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT OFF)
ENDIF()
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_TSQR
  HAVE_BELOS_TSQR
  "Enable TSQR (Tall Skinny QR factorization) as an orthogonalization method in Belos.  You must build Trilinos with both Epetra _and_ Tpetra enabled in order to use TSQR with Epetra objects."
  "${${PACKAGE_NAME}_ENABLE_TSQR_DEFAULT}")

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_TEUCHOS_TIME_MONITOR
  BELOS_TEUCHOS_TIME_MONITOR
  "Enable Teuchos timers (via TimeMonitor) in Belos solvers."
  ${${PROJECT_NAME}_ENABLE_TEUCHOS_TIME_MONITOR} )

TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_Tpetra_Timers
  HAVE_BELOS_TPETRA_TIMERS
  "Add timers to Belos::MultiVecTraits for Tpetra::MultiVector operations."
  NO )

#
# "Experimental" code lives in Belos, but is not quite ready for use
# by a general audience.  You have to enable the CMake option below in
# order to install experimental headers, include experimental source
# files in the libraries, and build experimental tests.
#
# It's up to Belos developers to define what headers and source files
# are experimental, and what tests depend on experimental code.  They
# must use ${PACKAGE_NAME}_ENABLE_Experimental to conditionally
# disable tests or examples that have a required dependency on
# experimental code.  (${PACKAGE_NAME} evaluates to Belos, but we
# write it out so you know what to look for in the file.)  Code that
# _optionally_ depends on experimental code must be protected by
# #ifdef HAVE_BELOS_EXPERIMENTAL ... #endif.
#
# Belos developers must maintain the lists of experimental header
# resp. source files in belos/src/CMakeLists.txt, as
# ${PACKAGE_NAME}_EXPERIMENTAL_HEADERS
# resp. ${PACKAGE_NAME}_EXPERIMENTAL_SOURCES.
#
# Note that some experimental files may be excluded from the release
# tarball.  Belos uses the TRIBITS_EXCLUDE_FILES macro later in
# this file to list the files and directories to exclude from the
# release tarball.  That macro must NOT include conditional
# expressions; it must evaluate to the same list, no matter how
# Trilinos is configured.  We ensure this in Belos by listing
# explicitly the files and directories to exclude from the release
# tarball, rather than using variables or conditional CMake
# expressions.
#
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_BELOS_EXPERIMENTAL
  "Enable experimental Belos solvers and features."
  NO )

# See above discussion of "experimental" Belos headers and source
# files.  belos/src/CMakeLists.txt may append to these lists.
SET(${PACKAGE_NAME}_EXPERIMENTAL_HEADERS "")
SET(${PACKAGE_NAME}_EXPERIMENTAL_SOURCES "")


######################################################################
## Add the libraries, tests, and examples
######################################################################

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

IF (Belos_ENABLE_Epetra)
  ADD_SUBDIRECTORY(epetra)
ENDIF()

IF (Belos_ENABLE_Tpetra)
  ADD_SUBDIRECTORY(tpetra)
ENDIF()


######################################################################
## Build list of files to exclude from the release tarball
######################################################################

#
# Exclude leftover GNU Autotools files.
#
TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

#
# Files and directories to exclude from the release tarball.
#
TRIBITS_EXCLUDE_FILES(
  src/BelosInnerSolveResult.hpp
  src/BelosInnerSolver.hpp
  src/BelosProjectedLeastSquaresSolver.hpp
  src/BelosInnerSolveResult.cpp
  test/ProjectedLeastSquaresSolver
)

######################################################################
## Do standard postprocessing
######################################################################

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/didasko/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Didasko)

#
# B) Set up package-specific options
#

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Latex
  HAVE_DIDASKO_LATEX
  "Enables compilation of LaTeX source files.[Note, this is currently unsupported]"
  OFF )

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(examples)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  examples/teuchos/xml-data
  src/.*.eps
  src/.*.tex
  src/.*.ps
  src/DOEbwlogo.pdf
  src/Makefile
  src/SANDreport.cls
  src/Trilinos60Tutorial.pdf
  src/Trilinos70Tutorial.pdf
  src/Trilinos80Tutorial.pdf
  src/TrilinosTutorial_ReviewAndApproval.doc
  src/chapterbox.pdf
  src/colabarticle.cls
  src/snllineblk.pdf
  src/tutorial_biblio.bib
  )

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/domi/CMakeLists.txt ===
# -*- cmake -*-

# @HEADER
# ***********************************************************************
#
#     Domi: Multi-dimensional Distributed Linear Algebra Services
#                 Copyright (2014) Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia
# Corporation, the U.S. Government retains certain rights in this
# software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Questions? Contact William F. Spotz (wfspotz@sandia.gov)
#
# ***********************************************************************
# @HEADER

INCLUDE(TribitsPackageMacros)
INCLUDE(TribitsAddOptionAndDefine)

#
# Define the package
TRIBITS_PACKAGE(Domi DISABLE_STRONG_WARNINGS)

#
# Standardized debugging options
TRIBITS_ADD_DEBUG_OPTION()

#
# Set up package-specific options
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_ABC
  HAVE_DOMI_ARRAY_BOUNDSCHECK
  "Enable Domi feature for array bounds checking."
  ${${PROJECT_NAME}_ENABLE_DEBUG}
  )

#
# Add the libraries, tests, and examples
ADD_SUBDIRECTORY(src)
TRIBITS_ADD_TEST_DIRECTORIES(test)

#
# Add the Parameter List documentation
TRIBITS_ADD_TEST_DIRECTORIES(doc/parameterList)

#
# Do standard postprocessing
TRIBITS_PACKAGE_POSTPROCESS()

=== packages/epetra/CMakeLists.txt ===


TRIBITS_PACKAGE(Epetra)

SET(${PACKAGE_NAME}_VERSION "3.7d")

#
#   Exception added to deal with fixed form Fortran code on XL
#
TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

if("${CMAKE_Fortran_COMPILER_ID}" MATCHES "XL|VisualAge")
     set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qfixed=72 -qxlines")
   endif()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_ABC
  HAVE_EPETRA_ARRAY_BOUNDS_CHECK
  "Enable array bounds checking on Epetra objects."
  ${${PROJECT_NAME}_ENABLE_DEBUG} )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_FORMAT_IO
  HAVE_FORMAT_IO
  "Enable format IO capability."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_WARNING_MESSAGES
  HAVE_WARNING_MESSAGES
  "Enable building with warning messages."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_FATAL_MESSAGES
  HAVE_FATAL_MESSAGES
  "Enable printing of fatal error messages."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_THREADS
  HAVE_THREADS
  "Enable threading support."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Fortran
  HAVE_FORTRAN_SUPPORT
  "Enable Fortran support in Epetra."
  ${${PROJECT_NAME}_ENABLE_Fortran} )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_DISABLE_READY_SEND_IN_DO_POSTS
  EPETRA_NO_READY_SEND_IN_DO_POSTS
  "Replace (barrier+MPI_Rsend) with MPI_Send in Epetra_MpiDistributor::DoPosts (EXPERIMENTAL)."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(Trilinos_NO_32BIT_GLOBAL_INDICES
  EPETRA_NO_32BIT_GLOBAL_INDICES
  "If option is enabled, 32 bit global indices are disabled.  One must use long long global indices only for maps."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(Trilinos_NO_64BIT_GLOBAL_INDICES
  EPETRA_NO_64BIT_GLOBAL_INDICES
  "If option is enabled, 64 bit global indices are disabled.  One must use int global indices only for maps."
  OFF )

IF(TPL_ENABLE_MKL)
  TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_MKL_SPARSE
    Epetra_ENABLE_MKL_SPARSE
    "If option is enabled, MKL functions will be used for sparse operations in Epetra."
    OFF )

  IF(Epetra_ENABLE_MKL_SPARSE)
    INCLUDE_DIRECTORIES(${TPL_MKL_INCLUDE_DIRS})

    TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_DISABLE_MKL_SPARSE_MM
      Epetra_DISABLE_MKL_SPARSE_MM
      "If option is turned on, MKL matrix-matrix functions will not be used for sparse operations in Epetra.  This does not affect the usage of MKL matrix-vector functions."
      OFF )

  ENDIF()

ELSE()
  IF(Epetra_ENABLE_MKL_SPARSE)
    MESSAGE(FATAL_ERROR "Epetra_ENABLE_MKL_SPARSE requires that MKL TPL be enabled.  Either enable the TPL or do not enable Epetra_ENABLE_MKL_SPARSE.")
  ENDIF()
ENDIF()

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  doc
  example/C_wrappers
  example/Fortran
  example/ImportExport
  example/InverseIteration
  example/MapColoring
  example/ReducedLinearProblem
  example/petra_howle
  example/petra_nonlinear
  example/petra_transpose
  src/Epetra_FastCrsMatrix.cpp
  src/Epetra_FastCrsMatrix.h
  src/Epetra_InvOperator.cpp
  src/Epetra_LinearProblemRedistor.cpp
  src/Epetra_LinearProblemRedistor.h
  src/Epetra_MpiSmpComm.*
  src/stamp-h.in
  src/xxemacs
  test/BasicPerfTest/runSummary
  test/Comm/simple_mpi.cpp
  test/Comm/threaded_Makefile
  test/Comm/threaded_main.cpp
  test/EpetraBenchmarkTest
  test/LinearProblemRedistor
  test/Makefile.template
  test/Map/c_main.c
  test/MultiVector/Makefile.purify
  test/OSKI
  test/VbrMatrix/Suppressions.in
  test/Vector/Makefile.purify
  test/testAll.*
  )

TRIBITS_PACKAGE_POSTPROCESS()

=== debian/changelog ===
trilinos (12.4.2-2) unstable; urgency=medium

  * add missing file to d/copyright
  * move doc related rules to *-indep targets (Closes: #816100)

 -- Felix Salfelder <felix@salfelder.org>  Tue, 01 Mar 2016 12:39:54 +0200

trilinos (12.4.2-1) unstable; urgency=medium

  [Nico Schlömer]
  * import new upstream release (Closes: #704782)
    - remove libtrilinos_ prefixes
    - clear patches
  * use local mathjax instead of cdn

  [Felix Salfelder]
  * build separate library packages
  * some lintian overrides
  * workaround (embed) Trilinos_Version.h
  * build documentation

 -- Nico Schlömer <nico.schloemer@gmail.com>  Tue, 24 Nov 2015 10:39:12 +0100

trilinos (10.4.0.dfsg-1) unstable; urgency=low

  [Christophe Prud'homme]
  * New upstream release
  * debian/control: update Standard-Version to 3.9.1

  [Johannes Ring]
  * Update patches for 10.4.0 release.
  * debian/rules: Remove DEB_MAKE_BUILD_TARGET.

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 13 Aug 2010 17:18:35 +0200

trilinos (10.0.4.dfsg-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't hardcode name of the default make target (closes: #577388).

 -- Jakub Wilk <jwilk@debian.org>  Wed, 19 May 2010 13:59:28 +0200

trilinos (10.0.4.dfsg-1) unstable; urgency=low

  [Christophe Prud'homme]
  * New upstream release
  * debian/control: updated Standard-Version to 3.8.3 (no changes)

  [Johannes Ring]
  * debian/patches: Update patches for 10.0.4 release.
  * debian/control:
    - Add XS-Python-Version field to source package and
      XB-Python-Version field to binary package python-pytrilinos.
    - Add python-numpy to Depends for binary package python-pytrilinos.
  * debian/rules: Fix issue with PyTrilinos and Python 2.6.
  * Switch from python-support to python-central.

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 03 Jan 2010 08:25:23 +0100

trilinos (10.0.3.dfsg-2) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/rules: enable noxlapack

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 21 Dec 2009 11:04:12 +0100

trilinos (10.0.3.dfsg-1) unstable; urgency=low

  [Christophe Prud'homme]
  * New upstream release

  [Johannes Ring]
  * debian/patches/libname.patch: Add prefix 'libtrilinos_' to all
    libraries.
  * debian/patches/soname.patch: Add soversion to libraries.
  * debian/watch: Update download URL.
  * debian/control:
    - Remove python-numeric from Build-Depends (virtual package).
    - Remove automake and autotools from Build-Depends and add cmake to
      reflect switch to CMake.
    - Add python-support to Build-Depends.
  * debian/rules:
    - Cleanup and updates for switch to CMake.

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 13 Dec 2009 12:53:22 +0100

trilinos (9.0.3.dfsg-2) unstable; urgency=low

  * debian/rules: fixed lintian warning (package-installs-python-pyc)
  * debian/control: updated Standard-=Version to 3.8.2 (no change)

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 14 Jul 2009 08:55:52 +0200

trilinos (9.0.3.dfsg-1) unstable; urgency=low

  [Christophe Prud'homme]
  * New upstream release
  * python-pytrilinos: fix lintian warning package-installs-python-pyc

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 03 Jul 2009 11:26:41 +0200

trilinos (9.0.2.dfsg-5) unstable; urgency=low

  [Fabrice Coutadeur]
  * Adapt package to python2.6 (LP: #386625):
    - debian/python-pytrilinos.install: changed python2.5 to python*
    - debian/control: changed build dependency from python2.5-dev to python-dev
    - debian/rules: changed reference to python2.5 to python2.6
    - debian/patches/python_2.6.patch: add --install-layout=deb to setup.py
      call in Makefile.in and Makefile.am for Packages/PyTrilinos/shared,
      packages/PyTrilinos/src and packages/Sundance/python/src

  [Christophe Prud'homme]
  * debian/rules: fix some lintian warnings
  * Bug fix: "trilinos FTBFS with python2.6", thanks to Fabrice Coutadeur
    (Closes: #535145).

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 03 Jul 2009 07:32:36 +0200

trilinos (9.0.2.dfsg-4) unstable; urgency=low

  * debian/rules: added sacado to TRILINOS_PACKAGES and
    TRILINOS_PACKAGES_LIBS, thanks to Adam for pointing this out.
  * debian/libtrilinos-dev.install: move /usr/include/*.h to
    /usr/include/trilinos, thanks to Adam for pointing this out.

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 22 May 2009 12:09:26 +0200

trilinos (9.0.2.dfsg-3) unstable; urgency=low

  * Added patch to fix gcc 4.4 FTBS
  * Bug fix: "missing #include", thanks to Martin Michlmayr (Closes:
    #527210).

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 12 May 2009 21:02:58 +0200

trilinos (9.0.2.dfsg-2) unstable; urgency=low

  * debian/rules: enable sacado
  * Bug fix: "Missing Sacado", thanks to Adam C Powell IV (Closes:
    #527835).
  * Bug fix: "error when trying to install together", thanks to Ralf
    Treinen (Closes: #526992).

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 09 May 2009 14:19:14 +0200

trilinos (9.0.2.dfsg-1) unstable; urgency=low

  * Initial release Closes: #362293
  * as per discussion with debian ftpmaster, renamed all libraries using
    prefix libtrilinos_, hence improving the library naming in trilinos

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 19 Mar 2009 10:50:42 +0100

=== debian/control ===
Source: trilinos
Homepage: http://trilinos.org
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Nico Schlömer <nico.schloemer@gmail.com>
Build-Depends: debhelper (>= 9),
 binutils-dev,
 libiberty-dev,
 cmake (>= 2.8.11),
 gfortran,
 libopenmpi-dev,
 libblas-dev,
 libboost-dev,
 libboost-system-dev,
 libboost-program-options-dev,
 libglm-dev,
 libhdf5-openmpi-dev,
 liblapack-dev,
 libmumps-dev (>= 4.10),
 libptscotch-dev,
 libsuperlu-dev,
 libtbb-dev,
 zlib1g-dev
Build-Depends-Indep: doxygen,
 ghostscript,
 graphviz,
 libjs-mathjax,
 python,
 texlive-binaries,
 texlive-latex-base,
 texlive-latex-extra
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/debian-science/packages/trilinos.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=debian-science/packages/trilinos.git

Package: trilinos-all-dev
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${mydevpackages}
Suggests: trilinos-doc
Description: object-oriented framework for large-scale problems - development files (ALL)
 The Trilinos Project is an effort to develop algorithms and enabling
 technologies within an object-oriented software framework for the
 solution of large-scale, complex multi-physics engineering and
 scientific problems. A unique design feature of Trilinos is its
 focus on packages.
 .
 This package depends on all Trilinos development packages.

Package: trilinos-dev
Architecture: any
Section: libs
Depends: ${misc:Depends}
Suggests: trilinos-doc
Description: object-oriented framework for large-scale problems - development files
 The Trilinos Project is an effort to develop algorithms and enabling
 technologies within an object-oriented software framework for the
 solution of large-scale, complex multi-physics engineering and
 scientific problems. A unique design feature of Trilinos is its
 focus on packages.
 .
 This package contains the development header and some makefile templates.

Package: libtrilinos-amesos12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: direct sparse solver package - runtime files
 Amesos is the Direct Sparse Solver Package in Trilinos. The goal of Amesos is
 to make AX=B as easy as it sounds, at least for direct methods. Amesos
 provides clean and consistent interfaces to a number of third-party libraries.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-amesos-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-amesos12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: direct sparse solver package - development files
 Amesos is the Direct Sparse Solver Package in Trilinos. The goal of Amesos is
 to make AX=B as easy as it sounds, at least for direct methods. Amesos
 provides clean and consistent interfaces to a number of third-party libraries.
 .
 This package provides headers.

Package: libtrilinos-amesos2-12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: next generation direct sparse solver package - runtime files
 Amesos2 is a package for solving sparse linear systems using direct solvers.
 It differs from Amesos in that it is templated on the scalar and index types.
 KLU2 is the only native solver.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-amesos2-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-amesos2-12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: next generation direct sparse solver package - development files
 Amesos2 is a package for solving sparse linear systems using direct solvers.
 It differs from Amesos in that it is templated on the scalar and index types.
 KLU2 is the only native solver.
 .
 This package provides headers.

Package: libtrilinos-anasazi12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: large-scale eigenvalue algorithms - runtime files
 Anasazi is an extensible and interoperable framework for large-scale
 eigenvalue algorithms. The motivation for this framework is to provide a
 generic interface to a collection of algorithms for solving large-scale
 eigenvalue problems. Anasazi is interoperable because both the matrix and
 vectors (defining the eigenspace) are considered to be opaque objects -- only
 knowledge of the matrix and vectors via elementary operations is necessary.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-anasazi-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-anasazi12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: large-scale eigenvalue algorithms - development files
 Anasazi is an extensible and interoperable framework for large-scale
 eigenvalue algorithms. The motivation for this framework is to provide a
 generic interface to a collection of algorithms for solving large-scale
 eigenvalue problems. Anasazi is interoperable because both the matrix and
 vectors (defining the eigenspace) are considered to be opaque objects -- only
 knowledge of the matrix and vectors via elementary operations is necessary.
 .
 This package provides headers.

Package: libtrilinos-aztecoo12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: object-oriented interface to the Aztec solver - runtime files
 AztecOO provides an object-oriented interface to the well-known Aztec solver
 library. Furthermore, it allows flexible construction of matrix and vector
 arguments via Epetra matrix and vector classes. Finally, AztecOO provide
 additional functionality not found in Aztec and any future enhancements to the
 Aztec package will be available only through the AztecOO interfaces.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-aztecoo-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-aztecoo12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: object-oriented interface to the Aztec solver - development files
 AztecOO provides an object-oriented interface to the well-known Aztec solver
 library. Furthermore, it allows flexible construction of matrix and vector
 arguments via Epetra matrix and vector classes. Finally, AztecOO provide
 additional functionality not found in Aztec and any future enhancements to the
 Aztec package will be available only through the AztecOO interfaces.
 .
 This package provides headers.

Package: libtrilinos-belos12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: iterative linear solvers - runtime files
 Belos provides next-generation iterative linear solvers and a powerful linear
 solver developer framework. This framework includes abstract interfaces to
 linear algebra using traits mechanisms, abstract interfaces to
 orthogonalization, abstract interfaces to iteration kernels, powerful solver
 managers, and a basic linear problem class.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-belos-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-belos12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: iterative linear solvers - development files
 Belos provides next-generation iterative linear solvers and a powerful linear
 solver developer framework. This framework includes abstract interfaces to
 linear algebra using traits mechanisms, abstract interfaces to
 orthogonalization, abstract interfaces to iteration kernels, powerful solver
 managers, and a basic linear problem class.
 .
 This package provides headers.

Package: libtrilinos-epetra12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: basis package for linear algebra - runtime files
 Epetra provides the fundamental construction routines and services function
 that are required for serial and parallel linear algebra libraries. Epetra
 provides the underlying foundation for all Trilinos solvers.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-epetra-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-epetra12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: basis package for linear algebra - development files
 Epetra provides the fundamental construction routines and services function
 that are required for serial and parallel linear algebra libraries. Epetra
 provides the underlying foundation for all Trilinos solvers.
 .
 This package provides headers.

Package: libtrilinos-epetraext12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extensions to the Epetra toolkit - runtime files
 EpetraExt provides tools and functions that make it easier to work with
 Epetra.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-epetraext-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-epetraext12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: extensions to the Epetra toolkit - development files
 EpetraExt provides tools and functions that make it easier to work with
 Epetra.
 .
 This package provides headers.

Package: libtrilinos-galeri12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: generation of distributed linear systems - runtime files
 The Trilinos package Galeri contains a suite of utilities and classes to
 generate a variety of (distributed) linear systems. Galeri's functionalities
 are very close to that of the MATLAB's gallery() function.
 Several well-known finite element and finite difference matrices can be
 generated using only a few simple code lines.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-galeri-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-galeri12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: generation of distributed linear systems - development files
 The Trilinos package Galeri contains a suite of utilities and classes to
 generate a variety of (distributed) linear systems. Galeri's functionalities
 are very close to that of the MATLAB's gallery() function.
 Several well-known finite element and finite difference matrices can be
 generated using only a few simple code lines.
 .
 This package provides headers.

Package: libtrilinos-globipack12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 1D globalization capabilities - runtime files
 The GlobiPack package contains a set of interfaces and implementations for 1D
 globalization capabilities to be used in nonlinear solvers, optimization
 solvers, and similar algorithms that require globalization methods (e.g. line
 search and trust region methods). Basic interfaces and a few implementations
 are present for 1D line search methods appropritate for Newton, quasi-Newton,
 and nonlinear CG algorithms.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-globipack-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-globipack12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: 1D globalization capabilities - development files
 The GlobiPack package contains a set of interfaces and implementations for 1D
 globalization capabilities to be used in nonlinear solvers, optimization
 solvers, and similar algorithms that require globalization methods (e.g. line
 search and trust region methods). Basic interfaces and a few implementations
 are present for 1D line search methods appropritate for Newton, quasi-Newton,
 and nonlinear CG algorithms.
 .
 This package provides headers.

Package: libtrilinos-ifpack12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: algebraic preconditioners - runtime files

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# dirnames deviate from package names...
LIB_PACKAGES = \
    amesos \
    amesos2 \
    anasazi \
    aztecoo \
    belos \
    epetra \
    epetraext \
    galeri \
    globipack \
    ifpack \
    ifpack2 \
    intrepid \
    isorropia \
    kokkos \
    komplex \
    ml \
    moertel \
    muelu \
    nox \
    optipack \
    pamgen \
    phalanx \
    pike \
    piro \
    pliris \
    rol \
    rtop \
    rythmos \
    sacado \
    shards \
    shylu \
    stokhos \
    stratimikos \
    teko \
    teuchos \
    thyra \
    tpetra \
    trilinoscouplings \
    triutils \
    xpetra \
    zoltan \
    zoltan2

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DOC_TRUE=
DOC_FALSE=
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
   DOC_TRUE=\#
else
   DOC_FALSE=\#
endif

%:
	dh $@

clean:
	rm -f *-stamp
	rm -rf debian/tmp_*
	rm -rf packages/*/doc/html
	rm -rf packages/*/browser/doc/html
	rm -rf packages/rtop/src/*/doc/html
	dh clean

override_dh_auto_build-arch:
	dh_auto_build -a --parallel

override_dh_auto_build-indep:
	dh_auto_build -i --parallel

override_dh_auto_configure: configure-stamp

configure-stamp:
	dh_auto_configure -- \
   -DCMAKE_C_COMPILER=mpicc \
   -DCMAKE_CXX_COMPILER=mpicxx \
   -DCMAKE_Fortran_COMPILER=mpif90 \
   -DBUILD_SHARED_LIBS:BOOL=ON \
   -DCMAKE_SKIP_RPATH:BOOL=ON \
   -DTrilinos_LIBRARY_NAME_PREFIX:STRING="trilinos_" \
   -DTrilinos_INSTALL_INCLUDE_DIR:PATH=include/trilinos/ \
   -DTrilinos_USE_GNUINSTALLDIRS:BOOL=ON \
   -DTrilinos_ENABLE_DEVELOPMENT_MODE:BOOL=OFF \
   -DTrilinos_ENABLE_ALL_PACKAGES:BOOL=ON \
   -DTrilinos_ENABLE_SECONDARY_TESTED_CODE:BOOL=ON \
   -DTrilinos_ASSERT_MISSING_PACKAGES:BOOL=OFF \
   -DTrilinos_ENABLE_EXPLICIT_INSTANTIATION:BOOL=ON \
   -DTrilinos_ENABLE_CTrilinos:BOOL=OFF \
   -DTrilinos_ENABLE_Didasko:BOOL=OFF \
   -DTrilinos_ENABLE_FEI:BOOL=OFF \
   -DTrilinos_ENABLE_ForTrilinos:BOOL=OFF \
   -DTrilinos_ENABLE_Gtest:BOOL=OFF \
   -DTrilinos_ENABLE_Mesquite:BOOL=OFF \
   -DTrilinos_ENABLE_MOOCHO:BOOL=OFF \
   -DTrilinos_ENABLE_Optika:BOOL=OFF \
   -DTrilinos_ENABLE_Panzer:BOOL=OFF \
   -DTrilinos_ENABLE_Phdmesh:BOOL=OFF \
   -DTrilinos_ENABLE_PyTrilinos:BOOL=OFF \
   -DTrilinos_ENABLE_SEACAS:BOOL=OFF \
   -DTrilinos_ENABLE_Sundance:BOOL=OFF \
   -DTrilinos_ENABLE_STK:BOOL=OFF \
   -DTrilinos_ENABLE_STKClassic:BOOL=OFF \
   -DTrilinos_ENABLE_STKDoc_tests:BOOL=OFF \
   -DTrilinos_ENABLE_STKSearch:BOOL=OFF \
   -DTrilinos_ENABLE_STKUnit_tests:BOOL=OFF \
   -DTrilinos_ENABLE_ThreadPool:BOOL=OFF \
   -DTrilinos_ENABLE_EXAMPLES:BOOL=OFF \
   -DTrilinos_ENABLE_TESTS:BOOL=OFF \
   -DTPL_ENABLE_BinUtils:BOOL=ON \
   -DTPL_ENABLE_Boost:BOOL=ON \
   -DTPL_ENABLE_HDF5:BOOL=ON \
     -DHDF5_INCLUDE_DIRS:PATH=/usr/include/hdf5/openmpi/ \
     -DHDF5_LIBRARY_DIRS:PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/openmpi/ \
   -DTPL_ENABLE_Matio:BOOL=OFF \
   -DTPL_ENABLE_MATLAB:BOOL=OFF \
   -DTPL_ENABLE_MPI:BOOL=ON \
   -DTPL_ENABLE_MUMPS:BOOL=ON \
   -DTPL_ENABLE_Netcdf:BOOL=OFF \
   -DTPL_ENABLE_ParMETIS:BOOL=OFF \
   -DTPL_ENABLE_Scotch:BOOL=ON \
     -DTPL_Scotch_INCLUDE_DIRS:PATH=/usr/include/scotch/ \
   -DTPL_ENABLE_SuperLU:BOOL=ON \
     -DSuperLU_INCLUDE_DIRS:PATH=/usr/include/superlu/ \
   -DTPL_ENABLE_TBB:BOOL=ON \
   -DTPL_ENABLE_X11:BOOL=OFF \
   -DTPL_ENABLE_Zlib:BOOL=ON
	touch $@

BUILDDIR=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)

doc_build-stamp: $(DOC_TRUE)$(LIB_PACKAGES:%=%_doc-stamp)
	touch $@

# ignoring return code. some parts just fail!
$(LIB_PACKAGES:%=%_doc-stamp): %_doc-stamp:
	-cd packages/$*/doc && ./build_docs
	touch $@

override_dh_auto_install-indep: auto_install-indep-stamp
override_dh_auto_install-arch: auto_install-arch-stamp

auto_install-indep-stamp: doc_build-stamp
	mkdir -p $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos;
	for i in $(LIB_PACKAGES); do \
	  echo "cp -r packages/$$i/doc/html/ $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos/$$i"; \
	  cp -r packages/$$i/doc/html/ $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos/$$i || :; \
	done
	touch $@

auto_install-arch-stamp:
	for i in $(LIB_PACKAGES); do \
     if [ -d $(BUILDDIR)/packages/$$i ]; then \
	    $(MAKE) -C $(BUILDDIR)/packages/$$i install DESTDIR=$(CURDIR)/debian/tmp_$$i || exit 1; \
	  else \
	    echo "WARNING: $@, no $$i has been built" >&2; \
       sleep 3; \
	  fi; \
	done
	$(MAKE) -C $(BUILDDIR) install/local DESTDIR=$(CURDIR)/debian/tmp_trilinos-dev
	touch $@

TV = SIERRA/bjam/config_headers/Trilinos_version.h
V = $(shell grep '\#define TRILINOS_MAJOR_VERSION ' $(TV) | cut -d' ' -f3)
MV = $(shell grep '\#define TRILINOS_MAJOR_MINOR_VERSION ' $(TV) | cut -d' ' -f3)

SOVERSION=$(V)

debian/Trilinos_version.h: debian/Trilinos_version.h.in auto_install-arch-stamp
	test -f $(TV)
	sed -e 's/%V/$(V)/' \
	    -e 's/%MV/$(MV)/' $< > $@

LO_DIR = /usr/share/lintian/overrides

override_dh_install-indep: install-indep-stamp
install-indep-stamp: auto_install-indep-stamp
	@for i in $(LIB_PACKAGES); do \
	  echo "dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/ || exit 1;" \
	  dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/ || exit 1; \
	done
	dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/doc
	if [ ! -d debian/trilinos-doc ]; then \
		echo it should really be there...; \
	fi
	find debian/trilinos-doc -type f -name *.html -print0 | xargs -0 \
		sed -i -e 's_http\(s\|\)://cdn.mathjax.org/mathjax/latest_/usr/share/javascript/mathjax_g' \
		       -e 's#jquery\.js#/usr/share/javascript/jquery/jquery.js#'; \
	find debian/trilinos-doc/usr/share -name jquery.js -delete; \
	touch $@

override_dh_install-arch: install-arch-stamp
install-arch-stamp: SHELL=/bin/bash
install-arch-stamp: auto_install-arch-stamp debian/Trilinos_version.h
	@for i in $(LIB_PACKAGES); do \
     if [ -d $(BUILDDIR)/packages/$$i ]; then \
	    echo "dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$${i/2/2-}"$(SOVERSION)" usr/lib/*/*.so.*"; \
	    dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$${i/2/2-}"$(SOVERSION)" usr/lib/*/*.so.* || exit 1; \
	    echo "dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$$i-dev --autodest usr/include usr/lib/*/*.so usr/lib/*/cmake"; \
	    dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$$i-dev --autodest usr/include usr/lib/*/*.so usr/lib/*/cmake || exit 1; \
	    if grep -q "^libtrilinos-$$i\>" debian/lintian-override.in; then \
	      install -d debian/libtrilinos-$${i/2/2-}$(SOVERSION)$(LO_DIR); \
	      echo creating $(LO_DIR)/libtrilinos-$${i/2/2-}$(SOVERSION); \
	      grep "^libtrilinos-$${i/2/2-}%V\>" debian/lintian-override.in |\
	        sed -e 's/%V/$(SOVERSION)/g' >\
	        debian/libtrilinos-$${i/2/2-}$(SOVERSION)$(LO_DIR)/libtrilinos-$${i/2/2-}$(SOVERSION); \
	    fi \
	  else \
	    echo "WARNING: $@, no $$i has been built" >&2; \
	  fi; \
	done
	# just check. should not find anything.
	-find debian/lib*-dev -name Trilinos_version.h -print -printf 'BUG, leftover %p'
	for i in `grep -l Trilinos_version\.h debian/lib*-dev/usr/include/trilinos/*ersion*`; do \
		echo fixing header $$i; \
		sed -e '/Trilinos_version/,$$d' $$i > debian/htmp; \
		cat debian/Trilinos_version.h >> debian/htmp; \
		sed -e '1,/Trilinos_version/d' $$i >> debian/htmp; \
		mv debian/htmp $$i; \
	done
	dh_install --sourcedir=debian/tmp_trilinos-dev -ptrilinos-dev --autodest usr/include usr/lib/*/cmake -V foo=bar
	touch $@

override_dh_prep:
	dh_prep
	echo mydevpackages=$(LIB_PACKAGES:%=libtrilinos-%-dev,) > debian/trilinos-all-dev.substvars

override_dh_strip:
	dh_strip -a --dbg-package=trilinos-dbg

.PHONY: override_dh_auto_configure override_dh_auto_install \
	override_dh_install-arch \
	override_dh_install-indep

=== debian/watch ===
version=3

https://trilinos.org/oldsite/download/files/trilinos-(.*)-Source.tar.bz2
